rc.conf.5: Improve moused_type description a bit more.
[dragonfly.git] / UPDATING
CommitLineData
d2a0decc
MD
1# Updating Information for DragonFly users.
2#
3#
4# This file should warn you of any pitfalls which you might need to work around
5# when trying to update your DragonFly system. The information below is
6# in reverse-time order, with the latest information at the top.
7#
8# If you discover any problem, please contact the bugs@lists.dragonflybsd.org
9# mailing list with the details.
d2a0decc 10
3522bdfe
SW
11+-----------------------------------------------------------------------+
12+ UPGRADING DRAGONFLY FROM 4.6 TO LATER VERSIONS +
13+-----------------------------------------------------------------------+
14
7efec73e
SW
15AHC, AHD, AIC, NCV, NSP AND STG DRIVERS REMOVED
16-----------------------------------------------
9ef43fc3 17
7efec73e
SW
18They were all in our X86_64_GENERIC kernel configuration file, along with
19the AHC_REG_PRETTY_PRINT and AHD_REG_PRETTY_PRINT options, so any custom
20configuration files derived from it need adjustment.
9ef43fc3 21
be813d7a
SW
22PORTAL FILE SYSTEM REMOVED
23--------------------------
24
25It has been broken for a long time now.
26
5cc5a38c 27BINUTILS 2.27 REPLACES 2.24, PRIMARY
28------------------------------------
29
30The oldest of the two versions of Binutils, version 2.24, was removed
31and replaced with Binutils 2.27. It becomes the primary version version
32of binutils and version 2.25 becomes the alternate.
33
34The accepted values of BINUTILSVER are now "binutils227" (default) and
35"binutils225". The building of Binutils 2.25 can be prevented by setting
36NO_ALTBINUTILS=yes in make.conf.
37
d6e8ab2d
SW
38COMPAT_43 KERNEL OPTION REMOVED
39-------------------------------
40
41It was commented out in our default configs for several years now, but
42might still be present in custom configs created before Nov. 2011.
43
adfb2c71
JM
44OPENSSL REMOVED
45---------------
46
47OpenSSL has been removed from base and replaced with a private version of
48LibreSSL. The previously installed OpenSSL libraries, headers, and man
49pages will remain on the system unless the "make upgrade" command is
50specifically instructed to remove them. To do this, define
51REMOVE_OPENSSL_FILES for the upgrade command, e.g.
52"make upgrade REMOVE_OPENSSL_FILES=yes"
53
5b245968
MD
5428-Oct-2016: openssl has been replaced by ressl. It is recommended that any
55stale OpenSSL files be removed to avoid configuration scripts from using
56the stale and potentially vulnerable version, but all binaries that are
57dynamically linked to the OpenSSL libraries should be rebuilt first to
58avoid breakage.
adfb2c71 59
9682bad8
TN
60OPENSSH HPN REMOVED
61-------------------
62
63It has become too cumbersome to maintain HPN patches in OpenSSH in base.
64To use OpenSSH in base remove HPN config, if you have added it.
65Check files below for HPN config, see a few lines below.
66 /etc/ssh/ssh_config, /etc/ssh/sshd_config, ~/.ssh/config
67sshd(8) will fail to start if HPN config is used.
68
69NOTE: HPN config in sshd_config will prohibit remote access to host using ssh.
70
71HPN config:
72HPNDisabled
73HPNBufferSize
74TcpRcvBuf
75TcpRcvBufPoll
76NoneEnabled
77NoneSwitch
78cipher MTR-AES-CTR
79cipher NONE
80
81OpenSSH HPN is a patch set to OpenSSH providing higher performance under some
82circumstances, especially for networking.
83If HPN functionality is needed, install security/openssh from dports.
84
859c2e53
SW
85CS, EX AND VX DRIVERS REMOVED
86-----------------------------
3522bdfe 87
859c2e53
SW
88The cs(4), ex(4) and vx(4) drivers have been removed. They were very
89old and its doubtful they ever worked properly in x86_64 but they were
90in X86_64_GENERIC, so custom configurations derived from it have to be
3a609f3d 91adjusted.
3522bdfe 92
82aec1d3
FT
93+-----------------------------------------------------------------------+
94+ UPGRADING DRAGONFLY FROM 4.4 TO LATER VERSIONS +
95+-----------------------------------------------------------------------+
96
f1826c3e
SW
97AMD REMOVED
98-----------
99
100The am-utils automounter suite has been removed. It stopped working
101at some point and was never fixed. autofs(5) and the associated
102userland has been brought in from FreeBSD and replaces it.
103
c222305f
SW
104AN DRIVER REMOVED
105-----------------
82aec1d3 106
c222305f
SW
107The an(4) driver has been removed. It was in the X86_64_GENERIC kernel
108config file, so any configurations derived from it have to be adjusted.
82aec1d3 109
c222305f
SW
110/DEV/DRI GROUP CHANGED
111----------------------
112
113The default group assigned to /dev/dri entries has been changed
114from 'wheel' to 'video' with the id of '44'. If you want to have
115access to the dri devices please add yourself to the video group
116with:
117
118# pw groupmod video -m $USER
82aec1d3 119
dbf3d3ba
JM
120+-----------------------------------------------------------------------+
121+ UPGRADING DRAGONFLY FROM 4.2 TO LATER VERSIONS +
122+-----------------------------------------------------------------------+
123
54af9d02
SW
124DSCHED REMOVED
125--------------
126
127dsched(4) has been removed and one of its kernel options, DSCHED_FQ, was
128in our default kernel config file. So the DSCHED_FQ option has been turned
129into a no-op for now and can be removed from custom configurations.
130
68ef81ed
SW
131EST DRIVER REMOVED, COMPILE_ET AND LIBCOM_ERR TOO
132-------------------------------------------------
133
134The est(4) driver has been removed. All CPUs it supported (except one)
135were 32 bits only. Those who are still using the Core 2 Duo T7500 should
136report back if there are any issues with this CPU and our regular ACPI
137P-state support.
138
139Also, compile_et(1) and com_err(3) have been removed as well. They
140should have been removed along with kerberos support, back in 2009.
141
dbf3d3ba
JM
142SEVERAL LOCALES RENAMED
143-----------------------
144
145Several locales were using obsolete and misleading names, and thus have
146been adjusted to current standards. Any users of the following locales
147need to select alternates:
148
149DFLY 4.2 locale DFLY 4.4 alterative locale
150--------------- ------------------------------------
151mn_MN.UTF-8 mn_Cyrl_MN.UTF-8
152no_NO.UTF-8 nb_NO.UTF-8 or nn_NO.UTF-8
153no_NO.ISO8859-1 nb_NO.ISO8869-1 or nn_NO.ISO8859-1
154no_NO.ISO8859-15 nb_NO.ISO8859-15 or nn_NO.ISO8859-15
155sr_YU.UTF-8 sr_Cyrl_RS.UTF-8 or sr_Latn_RS.UTF-8
156sr_YU.ISO8859-5 sr_Cyrl_RS.ISO8859-5
157sr_YU.ISO8859-2 sr_Latn_RS.ISO8859-2
158zh_CN.GBK zh_Hans_CN.GBK
159zh_CN.UTF-8 zh_Hans_CN.UTF-8
160zh_CN.eucCN zh_Hans_CN.eucCN
161zh_CN.GB2312 zh_Hans_CH.GB2312
162zh_CN.GB18030 zh_Hans_CH.GB18030
163zh_HK.Big5HKSCS zh_Hant_HK.Big5HKSCS
164zh_HK.UTF_8 zh_Hant_HK.UTF-8
165zh_TW.Big5 zh_Hant_TW.Big5
166zh_TW.UTF-8 zh_Hant_TW.UTF-8
167
2a617999
SW
168+-----------------------------------------------------------------------+
169+ UPGRADING DRAGONFLY FROM 4.0 TO LATER VERSIONS +
170+-----------------------------------------------------------------------+
171
65c3b857
JM
172BINUTILS 2.25 REPLACES 2.22, PRIMARY
173------------------------------------
174
175The oldest of the two versions of Binutils, version 2.22, was removed
176and replaced with Binutils 2.25. It becomes the primary version version
177of binutils and version 2.24 becomes the alternate. There are 8 current
178CVE written against 2.24, so for security reasons version 2.25 should
179always be used.
180
181The accepted values of BINUTILSVER are now "binutils225" (default) and
182"binutils224". The building of Binutils 2.24 can be prevented by setting
183NO_ALTBINUTILS=yes in make.conf.
184
72b78560
JM
185LOADER OPTIONS CHANGED
186----------------------
187
188Right after the development branch started, the Fred art accompanying the
189loader menu was improved. The line between Fred and the menu was removed
190by default (but can optionally be returned) and the placement shifted as
191a result. The drawing was improved, and the colored version was improved,
192changing the eyes and wing color from white to red. A new color version
193of Fred was added, one with a blue scheme.
194
195The loader menu defaults have changed since release 4.0: The vertical
196line was removed, the loader is displayed in color by default*, and the
197blue scheme is used.
198
199The loader.conf changes are:
200loader_color: option has been removed
201loader_plain: option has been added, it changed menu to monochrome
202fred_is_red: changes color scheme from blue to red
203fred_is_blue: option existed only on 4.1, it has been removed
204fred_separated: Adds line between Fred and menu (as seen previously)
205
206* If loader.conf defines "console" as "comconsole" or "console" is defined
207 in the environment as "comconsole" then color will not be displayed,
208 even if loader_plain value is "NO".
209
cbab4ab1
JM
210SENDMAIL REMOVED FROM BASE
211--------------------------
212
213The only Mail Transfer Agent provided now is DragonFly Mail Agent (dma).
214If the system being upgraded is still configured to use the sendmail
215binaries from base, the "make upgrade" command will fail.
216
217The administrator must change /etc/mail/mailer.conf to switch the
218mailwrapper to dma or a DPorts-based MTA prior to running the upgrade
219command that permanently removes sendmail executables and could
220potentially break a running mail server.
221
222Refer: http://www.dragonflybsd.com/docs/docs/newhandbook/mta/ for
223detailed instructions on how to configure the MTA selection.
224
a7ac1ee9
SW
225_KPOSIX_VERSION and P1003_1B OPTIONS REMOVED
226--------------------------------------------
227
228The _KPOSIX_VERSION and P1003_1B kernel options have been changed to
229no-ops. They can be removed from custom kernel configurations.
230
aa7c3d6b
FT
231SOUND SYSTEM UPDATED FROM FreeBSD 11-CURRENT
232--------------------------------------------
233
234Many more sound devices may be detected.
235
236If the default device choosen isn't to your liking, setting the sysctl
237hw.snd.default_unit to a different number will change it.
238
60a260ad
SW
239SCTP SUPPORT DROPPED
240--------------------
241
242Support for the SCTP protocol has been removed.
243
2a617999
SW
244OLD USB DRIVERS REMOVED
245-----------------------
246
247The old USB stack, along with the kernel config option "device oldusb"
248and the make.conf variable "WANT_OLDUSB" have been removed. This means
249that for custom kernel configuration files which were derived from a
250GENERIC or X86_64_GENERIC file prior to making the usb4bsd stack default,
251various (old USB stack specific) devices will now complain about being
252unknown:
253
254 * oldusb (obviously)
255 * natausb (not yet ported to usb4bsd)
256 * rue (not yet ported to usb4bsd)
257 * ugen (no longer needed in usb4bsd)
258 * urio (not yet ported to usb4bsd)
259 * uscanner (no longer needed in usb4bsd)
260
261They should be removed or commented out in such custom kernel configs.
262
4e8e707f
JM
263GCC 5
264-----
265
266The GCC 4.4 compiler has been retired. It has been replaced by a GCC 5.1.
267The following make.conf variables no longer work: NO_GCC44, NO_OBJC, and
268NO_CXX. The latter was never documented and the latest versions of GCC are
269partially written in C++ so a C++ compiler is no longer optional. In
270practical terms it has not been optional for many years as other base
271components are also written in C++. The resource savings by avoiding
272building Objective-C compiler is so small, the complexity added by NO_OBJC
273internally was deemed a bad tradeoff so that is the reason for its removal.
274Also note that no "info" pages are installed with GCC 5. After this entry
275was originally written, all info pages were removed from DragonFly.
276
277GCC 5.1 has been designated as the primary compiler. As such, there is a
278new make.conf variable, NO_ALTCOMPILER. It will block the rebuilding of
279the designated secondary compiler, GCC 4.7. However, while DPorts
280primarily uses GCC 5 to build ports now, it still uses GCC 4.7 as well, so
281if building ports from source is desired, don't block building of the
282secondary compiler.
e9b676f1 283
0055c35b
SW
284+-----------------------------------------------------------------------+
285+ UPGRADING DRAGONFLY FROM 3.8 TO LATER VERSIONS +
286+-----------------------------------------------------------------------+
287
2a617999 288SMP AND DEVICE_POLLING OPTIONS MADE UNKNOWN
39b3e0a1
SW
289-------------------------------------------
290
291DEVICE_POLLING was replaced by IFPOLL_ENABLE and the former SMP code is
292the default now (even on single-core systems), both for, like, 21 months.
293We kept the options around as no-ops as a convenience, to allow people
294using the same config for the then current release and the then current
295master. That period is now over, so any configs still having those
296options have to be adjusted.
297
10ceb702
SW
298SYSVIPC SYSCALLS MADE NON-OPTIONAL
299----------------------------------
300
301The code related to the SYSVMSG, SYSVSEM and SYSVSHM kernel options is
302now compiled in by default. The options are no-ops for now.
303
79a3e83f
SW
304DEFAULT DRIVER CHANGED FOR LSI "THUNDERBOLT" SERIES RAID CONTROLLERS
305--------------------------------------------------------------------
306
307The default driver for those controllers is now mrsas(4) due to reports
308of file system corruption using the mfi(4) driver. The whole issue (and
309how to deal with potential problems when switching) was explained here:
310
311http://lists.dragonflybsd.org/pipermail/users/2014-July/128703.html
312
313A tunable is provided for letting those controllers still attach via
314the mfi(4) driver, hw.mrsas.mfi_enable (see mrsas(4) manual page).
315
0055c35b
SW
316OLDER NETWORK DRIVERS MOVED TO I386 ONLY
317----------------------------------------
318
319The following drivers have been made i386 only: ed(4), sr(4), ng_sync_ar
320and ng_sync_sr. ed(4) used to be in X86_64_GENERIC, so it has to be
321removed in kernel configs derived from X86_64_GENERIC.
322
e19e3c77 323+-----------------------------------------------------------------------+
62d4130d 324+ UPGRADING DRAGONFLY FROM 3.6 TO LATER VERSIONS +
e19e3c77
SW
325+-----------------------------------------------------------------------+
326
a6a7c140
JS
327UPDATE FROM MOST RECENT 3.6
328---------------------------
329
330Versions of 3.6 built before June 25th have a bug where installworld might
331crash during installation of the new initrd. Upgrade to the latest version
332of 3.6 before updating to 3.8 or later.
333
7c87aae6
SW
334ATM, IPX, NCP AND NWFS SUPPORT DROPPED
335--------------------------------------
6f25d555
SW
336
337Support for the IPX and NCP network protocols and for mouting NetWare
7c87aae6 338file systems has been dropped. Dito for ATM protocol support.
6f25d555
SW
339
340INITRD IMAGES NOW INSTALLED BY DEFAULT
341--------------------------------------
342
343An initial ramdisk image is now installed in /boot/kernel/initrd.img.gz
344
345Older images installed under the file name of initrd.img will be removed
346automatically by the make upgrade process.
347
f0478b8b
SW
348USB4BSD IS NOW THE DEFAULT USB STACK
349------------------------------------
350
351To get back to the old stack, put "WANT_OLDUSB=yes" in /etc/make.conf and
352replace "device usb" with "device oldusb" in the kernel configuration.
353
e19e3c77
SW
354MORE ISA SUPPORT DROPPED
355------------------------
356
357ISA support has been dropped from the following drivers: adv(4), an(4),
358ar(4), cs(4), digi(4), ed(4), ep(4), ex(4), fe(4), lnc(4), sbni(4),
359si(4), sn(4), and stg(4).
360
9332798a 361+-----------------------------------------------------------------------+
62d4130d 362+ UPGRADING DRAGONFLY FROM 3.4 TO LATER VERSIONS +
9332798a
SW
363+-----------------------------------------------------------------------+
364
c04df145
JS
365ABI CHANGE
366----------
367
368Installed third-party software (dports) will have to be rebuilt after upgrade,
369or reinstalled from binary packages.
370
2b455b95
JS
371UPDATING FROM 3.4 TO 3.6
372------------------------
373
374This only applies for this specific upgrade due to locale changes; it is
375not needed for upgrades after 3.6. Please update in this order:
376
377make buildworld
378make buildkernel
379make installworld
380make installkernel
381*reboot*
382make upgrade
383
384See this mailing list post for details:
385http://lists.dragonflybsd.org/pipermail/users/2013-September/090163.html
386
9332798a
SW
387CYRIX OPTIONS REMOVED
388---------------------
389
390The following Cyrix related options have been removed: CPU_BTB_EN,
391CPU_CYRIX_NO_LOCK, CPU_DIRECT_MAPPED_CACHE, CPU_DISABLE_5X86_LSSER,
392CPU_FASTER_5X86_FPU, CPU_IORT, CPU_LOOP_EN, CPU_RSTK_EN, CPU_SUSP_HLT,
393CYRIX_CACHE_WORKS, and CYRIX_CACHE_REALLY_WORKS
394
395ISA SUPPORT REMOVED FROM RP(4)
396------------------------------
397
398ISA support has been removed from the rp(4) driver. It is now PCI only.
399
64aeb497 400+-----------------------------------------------------------------------+
62d4130d 401+ UPGRADING DRAGONFLY FROM 3.2 TO LATER VERSIONS +
64aeb497
SW
402+-----------------------------------------------------------------------+
403
d88b9605
SW
404COMPAT_SUNOS OPTION REMOVED
405---------------------------
406
407The COMPAT_SUNOS option has been removed. It was meant to provide binary
408compatibility with SunOS 4.x for the sparc32 port of 4.4BSD.
409
43f215d7
SW
410ISA SOUND CARD SUPPORT REMOVED
411------------------------------
412
413The following modules have been removed (all for ISA sound cards):
414snd_ad1816.ko, snd_ess.ko, snd_mss.ko, snd_sb8.ko, snd_sb16.ko, snd_sbc.ko
415
6100d1de
JM
416GCC 4.7
417-------
418
419DragonFly has switched base compilers. GCC 4.7 is now the default
420compiler and GCC 4.4 is the alternative compiler. The "NO_GCC47" make
421variable ceases to work now.
422
423Users who wish to build only GCC 4.7 have to use NO_GCC44 in the
424/etc/make.conf to prohibit GCC 4.4 from building. However, using it is
425highly discouraged. There are a few packages in pkgsrc that do not build
426with GCC 4.7 and the new "DPorts" system uses GCC 4.4 by default. At
427this time, it is recommended to keep both compilers on the base system.
428
2089bb7c
SW
429SMP OPTION REMOVED
430------------------
431
432The SMP kernel option has been made a no-op. All kernels now feature SMP
433support. If you have 'options SMP' in your kernel config, you can as well
434remove it.
435
1c297ed0
SW
436DEVICE_POLLING OPTION REPLACED BY IFPOLL_ENABLE OPTION, KTR_POLLING REMOVED
437---------------------------------------------------------------------------
640dc18f
SZ
438
439The DEVICE_POLLING kernel option has been made a no-op and it has been
440replaced by IFPOLL_ENABLE. If you have 'options DEVICE_POLLING' in your
441kernel config, you need to change it to IFPOLL_ENABLE.
442
1c297ed0
SW
443Also, the KTR_POLLING kernel option has been removed, so it must be
444removed from kernel configs that have it.
445
558b0a0b
SW
446BUSLOGIC, CYCLADES AND STALLION ISA SUPPORT REMOVED
447---------------------------------------------------
850c4634
SW
448
449The bt(4) driver for Buslogic SCSI adapters has been made PCI only. ISA
450cards will no longer be detected.
451
e6f626a1
SW
452The same has been done for Stallion multiport serial controllers. stli(4)
453has been completely removed (along with the stlload(8) and stlstty(8)
558b0a0b
SW
454utilities) and stl(4) was changed to support only PCI cards. Similarly,
455ISA support was removed from cy(4) too. All these drivers are i386 only.
e6f626a1 456
e98bcb27
SW
457COMPAT_OLDISA OPTION GONE
458-------------------------
459
460The i386 specific COMPAT_OLDISA kernel option has been removed, since
461nothing needs it anymore.
462
c691bb43 463+-----------------------------------------------------------------------+
62d4130d 464+ UPGRADING DRAGONFLY FROM 3.0 TO LATER VERSIONS +
c691bb43
SW
465+-----------------------------------------------------------------------+
466
467APIC_IO OPTION REMOVED
468----------------------
469
470The APIC_IO kernel option is no longer accepted after having been without
471effect for a while. The hw.ioapic_enable tunable now serves its purpose.
472If you have 'options APIC_IO' in your kernel config, you'll have to
473remove it.
474
6d488cc3
SW
475WATCHDOG_ENABLE & HW_WDOG OPTIONS REMOVED
476-----------------------------------------
cf03d6cd
SW
477
478The wdog framework is now compiled into our kernels by default, so the
6d488cc3 479options are no longer needed.
cf03d6cd 480
397ffc5c
SW
481DOSCMD(1) REMOVED
482-----------------
483
484doscmd(1) has been removed. It was i386 only. The doscmd(1) specific
485NO_X make.conf option was removed too.
486
a1404d4f
SW
487GCC 4.7
488-------
489
490GCC 4.7 has been brought in and replaces GCC 4.1 as DragonFly's non-
491default compiler in base (default is still GCC 4.4).
492
493Users who wish to build only GCC 4.4 have to replace NO_GCC41 with
494NO_GCC47 in /etc/make.conf.
495
2508820f
SW
496USB4BSD
497-------
498
499A new USB stack (from FreeBSD) has been brought in. The following
500modules have been ported so far: usb, uhci, ohci, ehci, xhci, umass,
501usfs, uether, if_axe, if_udav, ukbd, ums, uep, uhid, usb_quirk,
502and uaudio.
503
504It is not yet the default. To activate it, WANT_USB4BSD=yes has to
c7200221
SW
505be put in make.conf and device "usb4bsd" (quotes needed) has to
506replace device usb in the kernel config. After that, a full
507build/install/upgrade cycle is needed.
2508820f
SW
508
509Note that this is experimental and incomplete, but we are interested
510in hearing about issues with it, of course.
511
ae0870a3
SW
512ISA SUPPORT REMOVED FROM AIC-6260/6360 DRIVER
513---------------------------------------------
514
515ISA adapter support was dropped from the aic(4) driver.
516
96386d4b 517+-----------------------------------------------------------------------+
62d4130d 518+ UPGRADING DRAGONFLY FROM 2.10 TO LATER VERSIONS +
96386d4b
SW
519+-----------------------------------------------------------------------+
520
521SEVERAL ISA DRIVERS REMOVED
522---------------------------
523
524The following ISA only drivers have been removed along with a couple of
525associated userland tools:
526
527aha(4)
528asc(4) & sasc(1)
529ctx
530dgb(4)
531el(4)
532gpib
533gsc(4) & sgsc(1)
534ie(4)
535labpc(4)
536le(4)
537mse(4)
538rc(4)
539rdp(4)
540spigot
541tw(4) & xten(1) & xtend(8)
542wl(4) & wlconfig(8)
543wt(4)
544
545Note that two of these drivers (aha(4) and ie(4)) are in our GENERIC
546config and one (aha(4)) is in our X86_64_GENERIC kernel configuration
547file.
548
549If buildkernel complains about any of these drivers, just remove them
550from your kernel configuration.
551
919eb219
JM
552BINUTILS 2.20
553-------------
37c5a0db 554Binutils 2.20 has been removed in favor of Binutils 2.22. The accepted
e685772e 555values of BINUTILSVERS are now binutils221 and binutils222 (default).
919eb219 556
83bc1e2a
SW
557BUILDWORLD/-KERNEL PARALLELIZATION WORK
558---------------------------------------
559Due to changes in the way we build with more than one make job, you
560will have to update install(1) and mkdir(1) prior to buildworld if you
561want to build with 'make -j':
562
563cd /usr/src/usr.bin/xinstall; make; make install; make clean
564cd /usr/src/bin/mkdir; make; make install; make clean
565
eca86bd9
SW
566DMA(8) UPGRADE
567--------------
568dma(8) has been upgraded to v0.7 which no longer supports the
569/etc/dma/virtusertable. Some of its functionality has been replaced
570with the MASQUERADE keyword and the EMAIL environment variable (see
571the dma(8) manual page).
572
a4a39c94 573+-----------------------------------------------------------------------+
62d4130d 574+ UPGRADING DRAGONFLY FROM 2.8 TO LATER VERSIONS +
a4a39c94
JS
575+-----------------------------------------------------------------------+
576
b1242318
SW
577GCC 4.4 & BINUTILS 2.21
578-----------------------
30c91f0c 579
b1242318
SW
580GCC 4.4 has been made DragonFly's default compiler and Binutils 2.21 has
581been made DragonFly's default Binutils.
30c91f0c
SW
582
583That means that any settings that set CCVER to 'gcc44' are not needed
584anymore. Instead, CCVER can be set to 'gcc41' to go back to using
585GCC 4.1.
586
b1242318
SW
587It also means that 'binutils221' as a value for BINUTILSVER has no
588effect anymore. 2.17 has been removed and 'binutils220' is available
589as an option.
590
5738210d 591The NO_GCC44 option has been removed and will not affect the build
30c91f0c
SW
592anymore. There is now a NO_GCC41 option that will prevent GCC 4.1 from
593building in a similar fashion.
594
80abb3be 595Note that you must do a full buildworld/buildkernel for upgrading.
30c91f0c 596
a4a39c94 597pkg_radd settings
c983d16e 598-----------------
a4a39c94
JS
599
600The config file for pkg_radd has moved from /etc/settings.conf to
601/etc/pkg_radd.conf. Save the contents of settings.conf before upgrading
602if this is needed. This warning only applies if /etc/settings.conf
603exists. pkg_radd will continue to work with defaults.
604
b79f66dd 605+-----------------------------------------------------------------------+
72fe41d3 606+ 20100927 +
1bb1cc14 607+ UPGRADING DRAGONFLY FROM 2.6 to 2.8 or HEAD +
b79f66dd
JT
608+-----------------------------------------------------------------------+
609
72fe41d3 610OpenSSL
c983d16e 611--------
72fe41d3
PA
612
613OpenSSL has been upgraded, and SHLIB_MAJOR was bumped for libssh and libcrypto.
614This shouldn't break any 3rd-party software, but you'll need to recompile your
6153rd-party software if you want it to link against the new version of OpenSSL.
616
8eb0b612 617Loader
c983d16e 618-------
8eb0b612 619
b79f66dd
JT
620A new loader (dloader) has been added which better handles booting from
621multiple kernel/module versions.
622
623To upgrade (Only for this upgrade, for post 2.8 upgrades see GENERAL below)
624
625 cd /usr/src
626 make buildworld
627 make installworld
628 make upgrade
629 make buildkernel KERNCONF=<KERNELNAME>
630 make installkernel KERNCONF=<KERNELNAME>
631
632Note that you must installworld and run the 'upgrade' target before
633installing the new kernel.
634
8eb0b612 635BIND
c983d16e 636-----
8eb0b612
JS
637
638BIND has been removed from the base system. The ldns and drill tools have
639been added for basic functionality. Use 'drill' where you would normally
640use nslookup or dig, or install BIND from pkgsrc. It's available as
641net/bind95, net/bind96, or net/bind97 as of this writing.
642
643This only affects older systems upgrading to 2.8. New 2.8+ installs
644include BIND as a pkgsrc package.
645
d2a0decc
MD
646+-----------------------------------------------------------------------+
647+ UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM +
648+ GENERAL +
649+-----------------------------------------------------------------------+
984263bc 650
a700883c
SW
651Instructions on how to obtain and maintain DragonFly source code using git
652are in the development(7) manual page.
d2a0decc
MD
653
654To upgrade a DragonFly system from sources you run the following sequence:
655
656 cd /usr/src
657 make buildworld
658 make buildkernel KERNCONF=<KERNELNAME>
659 make installkernel KERNCONF=<KERNELNAME>
660 make installworld
661
662You will also want to run the 'upgrade' target to upgrade your /etc and the
663rest of your system. The upgrade target is aware of stale files created by
664older DragonFly installations and should delete them automatically.
665
666 make upgrade
667
a700883c
SW
668See the build(7) manual page for further information.
669
d2a0decc
MD
670Once you've done a full build of the world and kernel you can do incremental
671upgrades of either by using the 'quickworld' and 'quickkernel' targets
672instead of 'buildworld' and 'buildkernel'. If you have any problems with
a700883c 673the quick targets, try updating your repo first, and then a full buildworld
d2a0decc 674and buildkernel as shown above, before asking for help.
4523a2c0
TN
675
676+-----------------------------------------------------------------------+
677+ UPGRADING FROM DRAGONFLY <= 2.0 TO DRAGONFLY >= 2.1 +
678+-----------------------------------------------------------------------+
679
680In 2.1 kernel and modules has moved to boot directory. For most cases
681this is handled automatically by 'make upgrade'. A few cases needs manual
682intervention:
683
684 * When installing a kernel without first doing a make buildworld,
685 installworld and upgrade to the same DESTDIR as kernel:
686 make DESTDIR/boot directory and move kernel and modules into this boot
687 directory; also move kernel.old and modules.old.
688 Typical example is vkernel(7), use (no modules used):
689
690 cd /var/vkernel
691 mkdir boot
692 chflags noschg kernel
693 mv kernel kernel.old boot
694 chflags schg boot/kernel
695
696 * When using a boot-only partition, /boot/loader.rc needs to be edited:
697 delete occurrences of '/boot/'.
698 These occurences can normally be deleted in any case, see loader(8).
d2a0decc
MD
699
700+-----------------------------------------------------------------------+
701+ UPGRADING FROM DRAGONFLY <= 1.8 TO DRAGONFLY >= 1.9 +
702+-----------------------------------------------------------------------+
703
704In 1.9 major changes to the disk management infrastructure have taken
705place. make upgrade may not catch all of your disk devices in /dev,
706so after upgrading be sure to cd /dev; ./MAKEDEV <blah> where <blah>
45e80934
MD
707are all of your disk devices. HOWEVER, from late 2.3 on we run devfs
708and MAKEDEV no longer exists.
d2a0decc
MD
709
710The biggest changes in 1.9 are:
711
712(1) That whole-slice devices such as da0s1 no longer share the same device
713 id as partition c devices such as da0s1c.
714
715(2) The whole-disk device (e.g. da0) is full raw access to the disk,
716 with no snooping or reserved sectors. Consequently you cannot run
717 disklabel on this device. Instead you must run disklabel on a
718 whole-slice device.
719
720(3) The 'compatibility' partitions now use slice 0 in the device name,
721 so instead of da0a you must specify da0s0a. Also, as per (1) above,
722 accessing the disklabel for the compatibility partitions must be
723 done via slice 0 (da0s0).
724
725(4) Many device drivers that used to fake up labels, such as CD, ACD, VN,
726 and CCD now run through the disk management layer and are assigned
727 real disk management devices. VN and CCD in particular do not usually
728 use a MBR and disklabels must be accessed through the compatibility
729 slice 0. Your /etc/ccd.conf file still specifies 'ccd0', though, you
730 don't name it 'ccd0s0' in the config file.
731
732Generally speaking, you have to get used to running fdisk and disklabel on
733the correctly specified device names. A lot of the wiggle, such as running
734disklabel on a partition, has been removed.
735
736+-----------------------------------------------------------------------+
737+ UPGRADING FROM OLDER VERSIONS OF DRAGONFLY OR FREEBSD +
738+-----------------------------------------------------------------------+
739
740> Kerberos IV
741-------------
742
743Kerberos IV (eBones) was removed from the tree, please consider moving to
744Kerberos 5 (Heimdal).
745
746> Package Management System
747---------------------------
748
749Starting with the 1.4 release, DragonFly uses NetBSD's pkgsrc package
750management system. The necessary tools to build and maintain packages
751are provided in /usr/pkg/bin and /usr/pkg/sbin. Make sure that these
752directories are in your PATH variable.
753
754In order to obtain a reasonably current snapshot of the pkgsrc tree, use
755the tarball from NetBSD:
756
757 fetch -o /tmp/pkgsrc.tar.gz ftp://ftp.NetBSD.org/pub/NetBSD/packages/pkgsrc.tar.gz
758 cd /usr; tar -xzf /tmp/pkgsrc.tar.gz; chown -R root:wheel pkgsrc
759
760This tree can then be kept up to date with cvs update:
761
762 cd /usr/pkgsrc; cvs up
763
764NOTE! If you upgraded from a pre-1.4 system to 1.4 or later, you need to
765build and install the pkgsrc bootstrap manually:
766
767 cd /usr/pkgsrc/bootstrap
768 ./bootstrap --pkgdbdir /var/db/pkg --prefix /usr/pkg
769
770+-----------------------------------------------------------------------+
771+ UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM +
772+ UPDATING FROM PRE-1.2 SYSTEMS OR FreeBSD 4.x TO +
773+ DRAGONFLY 1.3+ (EITHER PREVIEW or HEAD) +
774+-----------------------------------------------------------------------+
58116288 775
114580ac 776The compatibility shims for the build environment have been removed, you
58116288
JS
777have to update to DragonFly 1.2 release branch first.
778
1fcc7462
JS
779The default PAM configuration has moved from /etc/pam.conf to /etc/pam.d/.
780The existing configuration can be converted using /etc/pam.d/convert.sh.
781Entries in /etc/pam.d/ override entries in /etc/pam.conf. In addition
782the pam_skey.so module was retired, you have to remove it manually from
783your configuration, when you convert it.
58116288 784
a3107071
MD
785> Required user and group IDs when upgrading from either FreeBSD or DragonFly
786---------------------
787
788The following users may be missing from your password file. Use vipw and
789add any that are missing:
790
791smmsp:*:25:25::0:0:Sendmail Submission User:/var/spool/clientmqueue:/sbin/nologin
dcf85892 792_pflogd:*:64:64::0:0:pflogd privsep user:/var/empty:/sbin/nologin
a3107071
MD
793
794The following groups may be missing from your group file. Use vi /etc/group
795and add any that are missing:
796
797smmsp:*:25:
798authpf:*:63:
dcf85892 799_pflogd:*:64:
a3107071
MD
800
801
f419daca 802> Upgrading to DragonFly from FreeBSD
5e0ae0d4 803---------------------
984263bc 804
f419daca
MD
805You can build the DragonFly world and DragonFly kernels on a FreeBSD-4.x or
806FreeBSD-5.x machine and then install DragonFly over FreeBSD, replacing
807FreeBSD. Note that the DragonFly buildworld target does not try to reuse
808make depend information, it starts from scratch, so no pre-cleaning of the
809object hierarchy is necessary.
810
466bbc10 811 # get the CVS repository (it is placed in /home/dcvs, 500MB).
f419daca
MD
812 # Please use the -h option and a mirror site to pull the
813 # initial repository, but feel free to use the main repository
814 # machine to pull updates.
5010eeb3 815 cvsup /usr/share/examples/cvsup/DragonFly-cvs-supfile
f419daca
MD
816 # install the source from the CVS hierarchy (remove preexisting
817 # FreeBSD src first) (500MB)
818 cd /usr
819 rm -rf src
50172b1c 820 cvs -R -d /home/dcvs checkout -P src
f419daca
MD
821
822 # build it (500MB used in /usr/obj)
823 #
824 cd /usr/src
825 make buildworld
826 make buildkernel KERNCONF=<KERNELNAME>
984263bc 827
f419daca
MD
828Once you have built DragonFly you have to install it over FreeBSD. Since
829DragonFly does not track changes made by FreeBSD to its include file
830hierarchy and include file pollution can cause all sorts of unexpected
831compilation issues to come up, it is best to wipe your include hierarchy
832prior to installing DragonFly. Note that you should not wipe any installed
833FreeBSD header files or binaries until after you have successfully completed
834the build steps above.
fb12f484 835
f419daca
MD
836 rm -rf /usr/include
837 mkdir /usr/include
838 make installkernel KERNCONF=<KERNELNAME>
839 make installworld
fb12f484 840
b8cbf045 841Then you need to upgrade your system. DragonFly's 'make upgrade' target
f419daca 842will unconditionally upgrade the /etc files that sysops do not usually
b8cbf045
SW
843mess around with, such as the files in /etc/rc.d. It will also remove any
844obsolete files such as utilities and manpages that have been removed from
845the system since the version you're coming from. If you are unsure we
846recommend that you make a backup of at least your /etc before applying
847this step. Note that DragonFly's RC system is basically RCNG from
848FreeBSD-5, but there are some differences in the contents of the RC files.
f419daca
MD
849
850 make upgrade
851
b8cbf045
SW
852NOTE! Never do a 'make upgrade' before 'make installworld' has been run.
853Doing so might leave your system in an unusable state.
854
f419daca 855Finally we recommend that you do an 'ls -lta BLAH' for /bin, /sbin, /usr/bin,
b8cbf045
SW
856/usr/bin, and /usr/lib, and remove any stale files that you find. Please
857report these files to the DragonFly developers so that they can be added to
858the 'upgrade' target.
f419daca 859